#include "myNeo.h"
#include "neomaple_hardware.h"

MyNeo::MyNeo() //konstruktor
{
  neomaple_hard_init(pixels);
}

MyNeo::~MyNeo()
{
}

uint8_t MyNeo::GetTC()
{
  return GetWS2812_TC();
}

void MyNeo::show(void)
{
  neomaple_hard_send(40 * 24,0);
}


void MyNeo::hide(void)
{
  neomaple_hard_send(40 * 24,1);
}


// Set pixel color from separate R,G,B components:
void MyNeo::setPixelColor(
    uint16_t n, uint8_t r, uint8_t g, uint8_t b)
{
  //zjisteni indexu vystupniho pinu
  uint8_t pinIndex = 0;
  while (n >= 40)
  {
    n -= 40;
    pinIndex++;
  }
  //zjisteni offsetu
  uint8_t pinOffset = (PIN_MAP[outPins[pinIndex]].gpio_bit);
  if (n < 40)
  {
    uint8_t i;
    for (i = 0; i < 8; i++)
    {
      uint32_t offset = (n * 24) + i;
      if ((g & (0x80>>i)) == 0) //green
      {
        pixels[offset] |= (1 << pinOffset); //set to one
      }
      else
      {
        pixels[offset] &= ~(1 << pinOffset); //set to zero
      }
      if ((r & (0x80>>i)) == 0) //red
       {
        pixels[offset+8] |= (1 << pinOffset); //set to one
      }
      else
      {
        pixels[offset+8] &= ~(1 << pinOffset); //set to zero
      }
      if ((b & (0x80>>i)) == 0) //blue
        {
        pixels[offset+16] |= (1 << pinOffset); //set to one
      }
      else
      {
        pixels[offset+16] &= ~(1 << pinOffset); //set to zero
      }
    }
  }
}

/*
void MyNeo::clear()
{
  memset(pixels, 1, 40 * 24);
}
*/